| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::TerrainMaterialGeneratorA::SM2Profile Class Reference

Shader model 2 profile target. More...

`#include <OgreTerrainMaterialGeneratorA.h>`

Inheritance diagram for Ogre::TerrainMaterialGeneratorA::SM2Profile:
[legend]

## Public Member Functions
| SM2Profile (TerrainMaterialGenerator *parent, const String &name, const String &desc)
virtual | ~SM2Profile ()
String | _getShaderLanguage () const
bool | _isSM3Available () const
| Internal. More...
bool | _isSM4Available () const
MaterialPtr | generate (const Terrain *terrain)
| Generate / reuse a material for the terrain. More...
MaterialPtr | generateForCompositeMap (const Terrain *terrain)
| Generate / reuse a material for the terrain. More...
const String & | getDescription () const
| Get the description of this profile. More...
uint8 | getMaxLayers (const Terrain *terrain) const
| Get the number of layers supported. More...
const String & | getName () const
| Get the name of this profile. More...
TerrainMaterialGenerator * | getParent () const
| Get the generator which owns this profile. More...
bool | getReceiveDynamicShadowsDepth () const
| Whether to use depth shadows (default false). More...
bool | getReceiveDynamicShadowsEnabled () const
| Whether to support dynamic texture shadows received from other objects, on the terrain (default true). More...
bool | getReceiveDynamicShadowsLowLod () const
| Whether to use shadows on low LOD material rendering (when using composite map) (default false). More...
PSSMShadowCameraSetup * | getReceiveDynamicShadowsPSSM () const
| Whether to use PSSM support dynamic texture shadows, and if so the settings to use (default 0). More...
bool | isCompositeMapEnabled () const
| Whether to use the composite map to provide a lower LOD technique in the distance (default true). More...
bool | isGlobalColourMapEnabled () const
| Whether to support a global colour map over the terrain in the shader, if it's present (default true). More...
bool | isLayerNormalMappingEnabled () const
| Whether to support normal mapping per layer in the shader (default true). More...
bool | isLayerParallaxMappingEnabled () const
| Whether to support parallax mapping per layer in the shader (default true). More...
bool | isLayerSpecularMappingEnabled () const
| Whether to support specular mapping per layer in the shader (default true). More...
bool | isLightmapEnabled () const
| Whether to support a light map over the terrain in the shader, if it's present (default true). More...
bool | isShadowingEnabled (TechniqueType tt, const Terrain *terrain) const
bool | isVertexCompressionSupported () const
| Compressed vertex format supported? More...
void | requestOptions (Terrain *terrain)
| Request the options needed from the terrain. More...
void | setCompositeMapEnabled (bool enabled)
| Whether to use the composite map to provide a lower LOD technique in the distance (default true). More...
void | setGlobalColourMapEnabled (bool enabled)
| Whether to support a global colour map over the terrain in the shader, if it's present (default true). More...
void | setLayerNormalMappingEnabled (bool enabled)
| Whether to support normal mapping per layer in the shader (default true). More...
void | setLayerParallaxMappingEnabled (bool enabled)
| Whether to support parallax mapping per layer in the shader (default true). More...
void | setLayerSpecularMappingEnabled (bool enabled)
| Whether to support specular mapping per layer in the shader (default true). More...
void | setLightmapEnabled (bool enabled)
| Whether to support a light map over the terrain in the shader, if it's present (default true). More...
void | setReceiveDynamicShadowsDepth (bool enabled)
| Whether to use depth shadows (default false). More...
void | setReceiveDynamicShadowsEnabled (bool enabled)
| Whether to support dynamic texture shadows received from other objects, on the terrain (default true). More...
void | setReceiveDynamicShadowsLowLod (bool enabled)
| Whether to use shadows on low LOD material rendering (when using composite map) (default false). More...
void | setReceiveDynamicShadowsPSSM (PSSMShadowCameraSetup *pssmSettings)
| Whether to use PSSM support dynamic texture shadows, and if so the settings to use (default 0). More...
virtual void | updateCompositeMap (const Terrain *terrain, const Rect &rect)
| Update the composite map for a terrain. More...
void | updateParams (const MaterialPtr &mat, const Terrain *terrain)
| Update params for a terrain. More...
void | updateParamsForCompositeMap (const MaterialPtr &mat, const Terrain *terrain)
| Update params for a terrain. More...

## Detailed Description

Shader model 2 profile target.

## Constructor & Destructor Documentation

## ◆ SM2Profile()

Ogre::TerrainMaterialGeneratorA::SM2Profile::SM2Profile | ( | TerrainMaterialGenerator * | parent,
|  | const String & | name,
|  | const String & | desc
| ) |  |

## ◆ ~SM2Profile()

virtual Ogre::TerrainMaterialGeneratorA::SM2Profile::~SM2Profile | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ generate()

MaterialPtr Ogre::TerrainMaterialGeneratorA::SM2Profile::generate | ( | const Terrain * | terrain | ) |
| virtual

Generate / reuse a material for the terrain.

Implements Ogre::TerrainMaterialGenerator::Profile.

## ◆ generateForCompositeMap()

MaterialPtr Ogre::TerrainMaterialGeneratorA::SM2Profile::generateForCompositeMap | ( | const Terrain * | terrain | ) |
| virtual

Generate / reuse a material for the terrain.

Implements Ogre::TerrainMaterialGenerator::Profile.

## ◆ getMaxLayers()

uint8 Ogre::TerrainMaterialGeneratorA::SM2Profile::getMaxLayers | ( | const Terrain * | terrain | ) | const
| virtual

Get the number of layers supported.

Implements Ogre::TerrainMaterialGenerator::Profile.

## ◆ updateParams()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::updateParams | ( | const MaterialPtr & | mat,
|  | const Terrain * | terrain
| ) |  |
| virtual

Update params for a terrain.

Implements Ogre::TerrainMaterialGenerator::Profile.

## ◆ updateParamsForCompositeMap()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::updateParamsForCompositeMap | ( | const MaterialPtr & | mat,
|  | const Terrain * | terrain
| ) |  |
| virtual

Update params for a terrain.

Implements Ogre::TerrainMaterialGenerator::Profile.

## ◆ requestOptions()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::requestOptions | ( | Terrain * | terrain | ) |
| virtual

Request the options needed from the terrain.

Implements Ogre::TerrainMaterialGenerator::Profile.

## ◆ isVertexCompressionSupported()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::isVertexCompressionSupported | ( |  | ) | const
| virtual

Compressed vertex format supported?

Implements Ogre::TerrainMaterialGenerator::Profile.

## ◆ isLayerNormalMappingEnabled()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::isLayerNormalMappingEnabled | ( |  | ) | const
| inline

Whether to support normal mapping per layer in the shader (default true).

## ◆ setLayerNormalMappingEnabled()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setLayerNormalMappingEnabled | ( | bool | enabled | ) |

Whether to support normal mapping per layer in the shader (default true).

## ◆ isLayerParallaxMappingEnabled()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::isLayerParallaxMappingEnabled | ( |  | ) | const
| inline

Whether to support parallax mapping per layer in the shader (default true).

## ◆ setLayerParallaxMappingEnabled()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setLayerParallaxMappingEnabled | ( | bool | enabled | ) |

Whether to support parallax mapping per layer in the shader (default true).

## ◆ isLayerSpecularMappingEnabled()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::isLayerSpecularMappingEnabled | ( |  | ) | const
| inline

Whether to support specular mapping per layer in the shader (default true).

## ◆ setLayerSpecularMappingEnabled()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setLayerSpecularMappingEnabled | ( | bool | enabled | ) |

Whether to support specular mapping per layer in the shader (default true).

## ◆ isGlobalColourMapEnabled()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::isGlobalColourMapEnabled | ( |  | ) | const
| inline

Whether to support a global colour map over the terrain in the shader, if it's present (default true).

## ◆ setGlobalColourMapEnabled()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setGlobalColourMapEnabled | ( | bool | enabled | ) |

Whether to support a global colour map over the terrain in the shader, if it's present (default true).

## ◆ isLightmapEnabled()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::isLightmapEnabled | ( |  | ) | const
| inline

Whether to support a light map over the terrain in the shader, if it's present (default true).

## ◆ setLightmapEnabled()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setLightmapEnabled | ( | bool | enabled | ) |
| virtual

Whether to support a light map over the terrain in the shader, if it's present (default true).

Implements Ogre::TerrainMaterialGenerator::Profile.

## ◆ isCompositeMapEnabled()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::isCompositeMapEnabled | ( |  | ) | const
| inline

Whether to use the composite map to provide a lower LOD technique in the distance (default true).

## ◆ setCompositeMapEnabled()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setCompositeMapEnabled | ( | bool | enabled | ) |

Whether to use the composite map to provide a lower LOD technique in the distance (default true).

## ◆ getReceiveDynamicShadowsEnabled()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::getReceiveDynamicShadowsEnabled | ( |  | ) | const
| inline

Whether to support dynamic texture shadows received from other objects, on the terrain (default true).

## ◆ setReceiveDynamicShadowsEnabled()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setReceiveDynamicShadowsEnabled | ( | bool | enabled | ) |

Whether to support dynamic texture shadows received from other objects, on the terrain (default true).

## ◆ setReceiveDynamicShadowsPSSM()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setReceiveDynamicShadowsPSSM | ( | PSSMShadowCameraSetup * | pssmSettings | ) |

Whether to use PSSM support dynamic texture shadows, and if so the settings to use (default 0).

## ◆ getReceiveDynamicShadowsPSSM()

PSSMShadowCameraSetup* Ogre::TerrainMaterialGeneratorA::SM2Profile::getReceiveDynamicShadowsPSSM | ( |  | ) | const
| inline

Whether to use PSSM support dynamic texture shadows, and if so the settings to use (default 0).

## ◆ setReceiveDynamicShadowsDepth()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setReceiveDynamicShadowsDepth | ( | bool | enabled | ) |

Whether to use depth shadows (default false).

## ◆ getReceiveDynamicShadowsDepth()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::getReceiveDynamicShadowsDepth | ( |  | ) | const
| inline

Whether to use depth shadows (default false).

## ◆ setReceiveDynamicShadowsLowLod()

void Ogre::TerrainMaterialGeneratorA::SM2Profile::setReceiveDynamicShadowsLowLod | ( | bool | enabled | ) |

Whether to use shadows on low LOD material rendering (when using composite map) (default false).

## ◆ getReceiveDynamicShadowsLowLod()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::getReceiveDynamicShadowsLowLod | ( |  | ) | const
| inline

Whether to use shadows on low LOD material rendering (when using composite map) (default false).

## ◆ _isSM3Available()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::_isSM3Available | ( |  | ) | const
| inline

Internal.

## ◆ _isSM4Available()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::_isSM4Available | ( |  | ) | const
| inline

## ◆ _getShaderLanguage()

String Ogre::TerrainMaterialGeneratorA::SM2Profile::_getShaderLanguage | ( |  | ) | const
| inline

## ◆ isShadowingEnabled()

bool Ogre::TerrainMaterialGeneratorA::SM2Profile::isShadowingEnabled | ( | TechniqueType | tt,
|  | const Terrain * | terrain
| ) |  | const

## ◆ getParent()

TerrainMaterialGenerator* Ogre::TerrainMaterialGenerator::Profile::getParent | ( |  | ) | const
| inline inherited

Get the generator which owns this profile.

## ◆ getName()

const String& Ogre::TerrainMaterialGenerator::Profile::getName | ( | void |  | ) | const
| inline inherited

Get the name of this profile.

## ◆ getDescription()

const String& Ogre::TerrainMaterialGenerator::Profile::getDescription | ( |  | ) | const
| inline inherited

Get the description of this profile.

## ◆ updateCompositeMap()

virtual void Ogre::TerrainMaterialGenerator::Profile::updateCompositeMap | ( | const Terrain * | terrain,
|  | const Rect & | rect
| ) |  |
| virtual inherited

Update the composite map for a terrain.

Referenced by Ogre::TerrainMaterialGenerator::updateCompositeMap().

The documentation for this class was generated from the following file:

- OgreTerrainMaterialGeneratorA.h